
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function Debug(o){
	lInfo.logln(o);
}


function prepareCurve(oDevice,curve_id,fLZ) {
	var deviceProductID=oDevice.productID;
	var deviceFirmwareID=oDevice.revisionID;

	if (curve_id<0) {
		return doCalcCurve(Math.abs(curve_id),[], 0, deviceProductID, deviceFirmwareID,false, 0);
	} 
	
	
	var oCatalog=JSON.parse(Property.getNode('dbcache').getValue());
	var dimmbar_ab=-1;
	var curve=[];
	var AnAb=0;
	lInfo.logln('suche Kurve '+curve_id);
	for (var iIndex=0;iIndex<oCatalog.illuminant.length;iIndex++)
		for (var jIndex=0;jIndex<oCatalog.illuminant[iIndex].curves.length;jIndex++) {
			var oItem=oCatalog.illuminant[iIndex].curves[jIndex];
			lInfo.logln('suche Kurve '+curve_id + ' = ' + oItem.id);
			if (oItem.id==curve_id) {
				lInfo.logln('kurve gefunden');
				dimmbar_ab=oItem.dimmMin;
				AnAb=oItem.dimmType;
				for (var kIndex=0;kIndex<oItem.values.length;kIndex++) {
					curve.push({pos:oItem.values[kIndex].pos, value:oItem.values[kIndex].val});
				}
				curve.sort(function(a,b){return a.pos-b.pos;});
			}
		} 
	
	if (dimmbar_ab==-1) {
		return false;
	} else {
		 
		return doCalcCurve(0, curve, dimmbar_ab, deviceProductID, deviceFirmwareID,fLZ, AnAb)		
	}
}

function executeProgramm(dsid,id) {
	lInfo.logln('starteProgrammierung fr ' + dsid + ' mit ' +id);
	 try {
	    var oDevice=getDevices().byDSID(dsid);
	    if (oDevice==null) {
	        sErrorMSG='Gert ' + dsid + ' nicht gefunden'
	        lWarn.logln(sErrorMSG);
	        new Event('led-wizard.step',{detail:'complete',error:true}).raise();
	        return;
	    }
	
		lInfo.logln('prepareCurfe ' + dsid + ' mit ' +id);
		
		var oParameterList=prepareCurve(oDevice,id,false);
		lInfo.logln('habe liste ' + oParameterList);		
		
		if (oParameterList==false) {
			lInfo.logln('Fehler!');
			new Event('led-wizard.step',{detail:'complete',error:true}).raise();
			return;
		}

		Property.setProperty('temp/value', JSON.stringify(oParameterList));
		Property.setProperty('temp/step', 0);
		Property.setProperty('temp/catalogeID', id);
		Property.setProperty('temp/dsid', dsid);
		
		new Event('led-wizard.step',{detail:'prepare','count':oParameterList.length}).raise();
						
	 } 
	 catch (e) {
		 lWarn.logln('Fehler '  + e);
		 new Event('led-wizard.step',{detail:'complete',error:true}).raise();
	 }
}


if (raisedEvent.parameter.actions != null) {
	Property.load();
	if (raisedEvent.parameter.actions == 'programmCurve') {		
    	executeProgramm(raisedEvent.parameter.dsid,raisedEvent.parameter.curve_id);        
    }
	
}

	
