Ext.define('DSS.addon.IlluminantTest', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    topPanel:null,
    topLabel:null,
    grafic : null,
    middlePanel : null,
    sliderPanel:null,
    buttonPanel:null,
    btnSend:null,
    btnTest:null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    nFieldPercent:null,
    nFieldSlider:null,
    btnMin:null,
    btnMax:null,
    btnInc:null,
    btnDec:null,
    btnMid:null,
    winWait:null,
    setHeight : function(oHeight) {
    	this.bottomPanel.setHeight(oHeight -85);
        this.leftPanel.setHeight(oHeight -90);
        this.rightPanel.setHeight(oHeight -90);
        this.leftButtonPanel.setHeight(oHeight -120);
        this.rightButtonPanel.setHeight(oHeight -120);
        
        this.grafic.setHeight(oHeight -90 -115);
        this.sliderPanel.setHeight(oHeight -140);
        this.nFieldSlider.setHeight(oHeight -180);
        this.iDefaultHeight = oHeight - 62;
        this.callParent(arguments);
    },
    setSlider:function(value) {
    	if (this.dssEditor.editControls.dsid.getValue()==null)
    		return;
        if (value>100)
            value=100;
        if (value<0)
            value=0;
        this.nFieldPercent.setValue(value);
        this.nFieldSlider.setValue(value);
                
        if (this.dssEditor.editControls.dsid.isValid())
        {
            var sSelected=this.dssEditor.editControls.dsid.getValue();
            dss.raiseEvent('led-wizard.demo',{actions:'setValue',dsid:this.dssEditor.editControls.dsid.getValue(),value:Math.floor((value*255)/100)});
        }
    },
    initStores : function() {
        if (Ext.data.StoreManager.lookup('illuminateChartValues') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'illuminateChartValues',
                fields : [ 'id','value'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });   
        }
    },
    
    setTestButton:function () {
        if (fActive) {
        	this.btnTest.setIcon('/framework/images/dss/stop.png');
        } else {
        	this.btnTest.setIcon('/framework/images/dss/start.png');
        }
        this.btnTest.setDisabled(false);
    },
    constructor : function(config) {
        this.initStores();
        var me = this;
        
        
        
        this.winWait= Ext.create('DSS.component.WaitForServerStepper',{
        	eventNameStart:'led-wizard.prog',
        	eventNameStep:'led-wizard.step',
        	endCallback:function () {me.dssEditor.fireEvent('save', null);}
        });
        this.btnSend=Ext.create('Ext.Button',{
            text:_('Send Dimmcurve'),
            width:200,
            height:30,
            margin: '0 20 0 0',
            //margin: '0 0 5 0',
            handler: function () {                
                if (me.dssEditor.editControls.dsid.isValid())
                    if (me.dssEditor.editControls.catalogeID.isValid())  {
                        me.winWait.start({actions:'programmCurve',dsid:me.dssEditor.editControls.dsid.getValue(),curve_id:me.dssEditor.editControls.catalogeID.getValue()});
                    }
            }
        });
        this.btnReset=Ext.create('Ext.Button',{
            text:_('Reset Dimmcurve'),
            width:200,
            height:30,
            //margin: '5 0 5 0',
            handler: function () {                
                if (me.dssEditor.editControls.dsid.isValid()) {
                		me.winWait.start({actions:'programmCurve',dsid:me.dssEditor.editControls.dsid.getValue(),curve_id:-1});
                }
            }
        });
        this.btnTest=Ext.create('Ext.Button',{
        	width:150,
        	margin: '3 0 10 0',
        	text:_('Test Dimmcurve'),
        	icon:'/framework/images/dss/start.png',
            handler: function () {
                if (me.dssEditor.editControls.dsid.isValid())
                {      
                    dss.raiseEvent('led-wizard.demo',{actions:'toggleDemoModus',dsid:me.dssEditor.editControls.dsid.getValue()});  
                    fActive=!fActive;
                    this.setDisabled(true);
                    function bound() {me.setTestButton()};
                    window.setTimeout(bound,1000);
                    
                }                
            }
        });
        this.btnMax=Ext.create('Ext.Button',{
            text:_('Max'),
            width:46,
            margin: '0 0 16 0',
            handler: function() {
                me.setSlider(100);
            }
        });
        this.btnInc = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-up-action',
            iconAlign: "top",
            id:'incButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 16 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()+10);
            }
        });
        this.btnMid=Ext.create('Ext.Button',{
            text:_('50%'),
            width:46,
            margin: '0 0 16 0',
            handler: function() {
                me.setSlider(50);
            }
        });
        this.ckbLeistungsZusatz=Ext.create('Ext.form.field.Checkbox', {
            boxLabel : _('Use Leistungszusatz'),
            allowBlank : false
        });
        this.btnDec = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-down-action',
            iconAlign: "top",
            id:'decButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 16 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()-10);
            }
        });
        this.btnMin=Ext.create('Ext.Button',{
            text:_('Min'),
            width:46,
            margin: '0 0 0 0',
            handler: function() {
                me.setSlider(0);
            }
        });
        this.btnMinDim=Ext.create('Ext.Button',{
            text:_('-'),
            width:46,
            margin: '0 0 0 0',
            handler: function() {
            	var devID=me.dssEditor.editControls.catalogeID.getValue();
            	if (devID==null)
            		return;
            	var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('id',devID,0,false,false,true);
        		if (oRecord!=null) {
        			me.setSlider(oRecord.get('dimmMinimum'));
        		} 		        			                
            }
        });
       
        this.topLabelLM=Ext.create('Ext.form.field.Display',{
            fieldLabel:_('illuminant'),
            width:750,
            value:'-'
        });
        this.topLabelDevice=Ext.create('Ext.form.field.Display',{
            fieldLabel:_('selected Device'),
            width:750,
            value:'-'
        });
        this.nFieldPercent=Ext.create('Ext.form.field.Number',{
            minValue:0,
            maxValue:100,
            step:1,
            margin: '0 0 16 0',
            decimalPrecision:0,
            width:50,
            listeners: {
                change: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        this.nFieldSlider=Ext.create('Ext.slider.Single', {
            width: 50,
            value: 50,
            increment: 1,
            minValue: 0,
            maxValue: 100,
            vertical:true,
            padding : "0 0 0 12",
            listeners: {
                change: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        this.grafic = Ext.create('Ext.chart.Chart', {
            store:Ext.data.StoreManager.lookup('illuminateChartValues'),
            height : 200,
            width: 470,
            animate: true,
            series: [ {
                         type: 'line',
                         xField: 'id',
                         yField: 'value',
                         fill: true,
                         markerConfig: {
                             type: 'circle',
                             radius: 4,
                             'fill': '#ffff00'
                         },
                         style: {
                        	 fill:'#dff6e8',
                        	 stroke:'#99E8BC',
                        	 opacity: 1
                         }
                     }]
        });
        
        
        
        this.leftButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'vbox',
                align:'center'
            },
            border:0,
            width:50,
            enabled:false,
            items:[this.nFieldPercent,this.btnMid,this.btnMinDim]
        }); 

        this.rightButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'vbox',
                align:'center'
            },
            border:0,
            width:50,
            enabled:false,
            items:[this.btnMax,this.btnInc,this.btnDec,this.btnMin]
        });
       
        this.sliderPanel=Ext.create('Ext.panel.Panel',{
            layout:{type:'hbox'}, 
            width:150,
            border:0,
            items:[this.leftButtonPanel,this.nFieldSlider,this.rightButtonPanel]
        });
        
        
        this.bigButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox',
                align:'center',
                pack:'center'
            },
            align:'middle',
            width:530,
            height:65,
            border:0,
            items:[this.btnSend,this.btnReset]
        });
        
        this.leftPanel=Ext.create('Ext.form.FieldSet',{
            layout : {
                type : 'vbox',
                align:'center',
                pack:'center'
            },
            padding: '5 20 0 20',
            width:550,
            height:30,
            align:'middle',

            border:0,
            items:[this.bigButtonPanel,this.grafic]
        });
        
        this.rightPanel=Ext.create('Ext.form.FieldSet',{
            layout : {
                type : 'vbox'
            },
            width:200,
            height:30,
            align:'middle',
            padding:"20 0 0 20",
            border:0,
            items:[this.btnTest,this.sliderPanel]
        });
        
         this.bottomPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox'
            },
            width:750,
            height:200,
            border:0,
            items:[this.leftPanel,this.rightPanel]
        });
        Ext.apply(this, {
            layout : {
                type : 'vbox'
            },
            padding: '0 0 0 10',
            items : [this.topLabelDevice,this.topLabelLM,this.bottomPanel, this.ckbLeistungsZusatz ]
        });
        this.callParent(arguments);	
        fChangedCallback.push(function () {me.setTestButton()});
    },
    updateLabels : function () {
    	var oDev=this.dssEditor.editControls.dsid.getValue();
    	var oIllu=this.dssEditor.editControls.catalogeID.getValue();
    	
    	if ((oDev!=null)&&(oIllu!=null)) {
    		this.btnSend.setDisabled(false);
    		this.ckbLeistungsZusatz.setDisabled(false);
    	} else {
    		this.btnSend.setDisabled(true);
    		this.ckbLeistungsZusatz.setDisabled(true);
    	}
    	   	
    	if (oDev!=null) {
	    	var oDevice = dss.staticDataModel.getDevice(oDev);	
	        var sString = oDevice.name + _(" in ");
	        sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
	        this.topLabelDevice.setValue(sString);
	        this.btnReset.setDisabled(false);
	        this.btnDec.setDisabled(false);
	        this.btnInc.setDisabled(false);
	        this.btnMax.setDisabled(false);
	        this.btnMid.setDisabled(false);
	        this.btnMin.setDisabled(false);
	        this.btnMinDim.setDisabled(false);
	        this.btnTest.setDisabled(false);
	        this.nFieldSlider.setDisabled(false);
	        this.nFieldPercent.setDisabled(false);
	       
    	} else {
    		this.topLabelDevice.setValue('-');
	        this.btnReset.setDisabled(true);
	        this.btnDec.setDisabled(true);
	        this.btnInc.setDisabled(true);
	        this.btnMax.setDisabled(true);
	        this.btnMid.setDisabled(true);
	        this.btnMin.setDisabled(true);
	        this.btnMinDim.setDisabled(true);
	        this.btnTest.setDisabled(true);
	        this.nFieldSlider.setDisabled(true);
	        this.nFieldPercent.setDisabled(true);
	        
    	}
    	
    	if (oIllu!=null) {
    		var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('id',oIllu,0,false,false,true);
    		if (oRecord!=null) {
    			var manuID=oRecord.get('manufactureID');
    			var oVendorRecord=Ext.data.StoreManager.lookup('illuminateVendorStore').findRecord('id',manuID,0,false,false,true);
    			this.topLabelLM.setValue(oVendorRecord.get('vendor') + ' ' + oRecord.get('socket') + ' ' + oRecord.get('name') + ' ' + oRecord.get('watt') + 'W ' + oRecord.get('colortemp'));
    			this.btnMinDim.setText(oRecord.get('dimmMinimum')+"%");
    		} else    		
    			this.topLabelLM.setValue('-');
    	} else {
    		this.topLabelLM.setValue('-');
    	}
    	
    },
    reset : function() {
    	var me=this;
    	 this.dssEditor.oTabPanelParent.on('tabchange', function ( tabPanel, newCard, oldCard, eOpts) {
         	me.updateLabels();
         });
    },
    setValue : function(value) {
    },
    isValid : function() {
        return true;
    },
    getValue : function() {
    }
});
